/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Soyapi Mumba.
 *
 * Portions created by the Initial Developer are Copyright (C) 2005,2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var SWEditEngine = {
	/*
	swEngine: "",
	swServiceList: "",
	swEngineList: "",
	prefs: "",
	swPrefs: "", 
	svcPrefs: "",
	enginePrefs: "",
	swPrefsString: "extensions.searchwith.",
	engineId: "",
	*/
	//engineLabel: "",
    gLeftUrl: "",
	gEngineName: "",
	
	onLoad: function() 
	{
		var engineList = window.arguments[0];
		var engineId = engineList.selectedItem.value;
		var theEngine = new SWEngine(engineId);
		var engineName =  theEngine.getName();
		this.gEngineName = engineName;
		
		var swPrefPane = document.getElementById("paneSWEditEngine");
		var engineLabel = document.getElementById("searchwith-prefs-engine-label");
		var prefLabel = swPrefPane.preferenceForElement(engineLabel);
		prefLabel.setAttribute("name", "extensions.searchwith.engine-list."+engineId);
	
		var engineLeftURL = document.getElementById("searchwith-prefs-engine-lefturl");
		var prefEngineLeftURL = swPrefPane.preferenceForElement(engineLeftURL);
		prefEngineLeftURL.setAttribute("name", "extensions.searchwith.engine."+engineId+".lefturl");
	
		var engineRightURL = document.getElementById("searchwith-prefs-engine-righturl");
		var prefEngineRightURL = swPrefPane.preferenceForElement(engineRightURL);
		prefEngineRightURL.setAttribute("name", "extensions.searchwith.engine."+engineId+".righturl");
	
		var engineIconPath = document.getElementById("searchwith-prefs-engine-iconpath");
		var prefEngineIconPath = swPrefPane.preferenceForElement(engineIconPath);
		prefEngineIconPath.setAttribute("name", "extensions.searchwith.engine."+engineId+".iconpath");
		
		prefLabel.value = engineName;
		if (engineLabel.value.length<1 && engineName.length>0) {
			engineLabel.value = engineName;
		}
		
		try {
			prefLabel.value = theEngine.getName();
			prefLabel.updateElements();
		} catch(e) {
		}
		
		try {
			prefEngineLeftURL.value = theEngine.getLeftUrl();	
			this.gLeftUrl = prefEngineLeftURL.value;
			prefEngineLeftURL.updateElements();
		} catch(e) {
		}
		
		try {
			prefEngineRightURL.value = theEngine.getRightUrl();
			prefEngineRightURL.updateElements();
		} catch(e) {
		}
		
		try {
			prefEngineIconPath.value = theEngine.getIconPath();
			prefEngineIconPath.updateElements();
		} catch(e) {
		}
	
		this.populateServices();
	},
	
	populateServices: function() {
		var swPrefPane = document.getElementById("paneSWEditEngine");
		var swServices = SearchWith.getServices();	
		var swServiceList = document.getElementById("searchwith-prefs-engine-service");
		var engineList = window.arguments[0];
		var engineId = engineList.selectedItem.value;
		var currentEngine = new SWEngine(engineId);
		var prefService = swPrefPane.preferenceForElement(swServiceList);
		
		prefService.setAttribute("name", "extensions.searchwith.engine."+engineId+".service");
		prefService.updateElements();
		
		var mi;
		for (svc in swServices) {
			var thisService = new SWService(swServices[svc]);
			mi = swServiceList.appendItem(thisService.getName(), swServices[svc]);
			mi.setAttribute("label", thisService.getName());
			mi.setAttribute("value", swServices[svc]);
			if (swServices[svc] == currentEngine.getServiceId()) {
				swServiceList.selectedItem = mi;
				prefService.value = swServices[svc];
			}
		}
	},
	
	acceptDialog: function() 
	{
		var theEngineList = window.arguments[0];
		var theEngineName = document.getElementById("searchwith-prefs-engine-label");
		var theLeftUrl = document.getElementById("searchwith-prefs-engine-lefturl");
		
		if (theLeftUrl.value.length < 1) {
			alert(SearchWith.getPropString("enter.search.address", "searchwith-strings"));
			return false;
		}
		theEngineList.selectedItem.label = theEngineName.value;
		return true;
	},
	
	cancelDialog: function() 
	{
		var theEngineList = window.arguments[0];
		var theLeftUrl = document.getElementById("searchwith-prefs-engine-lefturl");
		theLeftUrl.value = this.gLeftUrl;
		theEngineList.selectedItem.label = this.gEngineName;
		return true;
	},
	
	saveService: function() 
	{
		var serviceList = document.getElementById("searchwith-prefs-engine-service");
		return serviceList.selectedItem.value;
	},
	
	saveName: function() 
	{
		var aEngineList = window.arguments[0];
		var engineLabel = document.getElementById("searchwith-prefs-engine-label");
		
		if (engineLabel.value.length >0) {
			aEngineList.selectedItem.label = engineLabel.value;
		}
		return engineLabel.value;
	}

};



